import { Emitter } from 'better-emitter';
interface BasicObservable<T> extends Emitter {
    get(): T;
    set(newValue: T): void;
    locked(): boolean;
}
interface WargObservable<T> extends BasicObservable<T> {
    subscribe(cb: (T: any) => void): () => void;
    map<R>(fn: (T: any) => R): WargObservable<R>;
}
declare type DependencyObject<T extends {
    [key: string]: any;
}> = {
    [key in keyof T]: BasicObservable<T[key]>;
};
export declare const value: <T>(value: T) => WargObservable<T>;
export declare const computed: <D extends {
    [key: string]: any;
}, T>(dependencies: DependencyObject<D>, calculation: (D: any) => T) => WargObservable<T>;
export {};
